/********************************** (C) COPYRIGHT  *******************************
* File Name          : CH395_network_operation.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/10/12
* Description        : 
*******************************************************************************/ 
#include "CH395_network_operation.h"
#include "CH395_interface_operation.h"
#include "MCU_communication_interface.h"
#include "CH395inc.h"
#include "CH395.h"
#include "delay.h"
#include "string.h"
#include "stdio.h"


extern uint8_t local_ip[4];                   
extern uint8_t gateway_ip[4];               
extern uint8_t mask_ip[4];                     

extern uint8_t  Socket0DesIP[4];                                        
extern uint16_t http_port;                       

extern struct   _SOCK_INF sockinf[8];                                
extern struct   _CH395_SYS  ch395inf;                                                                

/*******************************************************************************
* Function Name  : CH395_init
* Description    : CH395ʼ
* Input          : None
* Return         : ʼ״̬
*******************************************************************************/
uint8_t CH395_init(void)
{
  uint8_t i;
		
	i=ch395_cmd_check_exist(0x65);
	if(i != 0x9a)return CH395_ERR_UNKNOW;
	i = ch395_cmd_get_ver();

  ch395_cmd_set_ipaddr(ch395inf.IPAddr);        
  ch395_cmd_set_gw_ipaddr(ch395inf.GWIPAddr);   
  ch395_cmd_set_maskaddr(ch395inf.MASKAddr);
	ch395_set_start_para(FUN_PARA_FLAG_TCP_SERVER|SOCK_DISABLE_SEND_OK_INT);	
	delay_ms(300); 
  i = ch395_cmd_init();                         
	printf("ch395_cmd_init : %2x\r\n",i);
	
  return i;
}
/*******************************************************************************
* Function Name  : ch395_inf_init
* Description    : CH395Ϣʼ
* Input          : None
* Return         : ʼ״̬
*******************************************************************************/
void ch395_inf_init(void)
{
    memset(&ch395inf, 0, sizeof(ch395inf));        /* CH395Infȫ */
    memcpy(ch395inf.IPAddr, local_ip, 4);          /* IPַдCH395Inf */
    memcpy(ch395inf.GWIPAddr, gateway_ip, 4);      /* IPַдCH395Inf */
    memcpy(ch395inf.MASKAddr, mask_ip, 4);         /* дCH395Inf */
}

void ch395_socket_init(void)
{
	uint8_t i;
	
	memset(&sockinf[1],0,sizeof(sockinf[1]));                     
	sockinf[1].SourPort = http_port;              
	sockinf[1].ProtoType = PROTO_TYPE_TCP;                      
	sockinf[1].TcpMode = TCP_SERVER_MODE;                           
	
	for(i=2;i<5;i++)
	{
		memset(&sockinf[i],i,sizeof(sockinf[i]));                      
		sockinf[i].SourPort = http_port;             
		sockinf[i].ProtoType = PROTO_TYPE_TCP;                       
	}
}

/*******************************************************************************
* Function Name  : socket_open
* Description    : CH395socke¿ªƴ
* Input          : None
* Return         : None
*******************************************************************************/
void socket_open(void)
{
	uint8_t i,rc;
 
	ch395_set_socket_prot_type(1,sockinf[1].ProtoType);
	ch395_set_socket_sourport(1,sockinf[1].SourPort);
	rc=ch395_open_socket(1);
	stop_if_error(rc); 
	rc=ch395_tcp_listen(1);
  stop_if_error(rc); 
	
	for(i=2;i<5;i++)
	{
		ch395_set_socket_prot_type(i,sockinf[i].ProtoType);
	  ch395_set_socket_sourport(i,http_port);
	}
  delay_ms(300);
}
/*******************************************************************************
* Function Name  : socket_open
* Description    : CH395socke
* Input          : None
* Return         : None
*******************************************************************************/
void ch395_set_socket(uint8_t socketid, uint8_t tcp_mode, uint16_t desport, uint16_t srcport)
{
//	uint8_t rc;

	ch395_set_socket_prot_type(socketid,PROTO_TYPE_TCP);
	ch395_set_socket_sourport(socketid,srcport);
//	switch(tcp_mode)
//	{
//		case TCP_SERVER_MODE:
//			  sockinf[socketid].TcpMode = TCP_SERVER_MODE;
//		    rc=ch395_open_socket(socketid);
//		    stop_if_error(rc);
//		    rc=ch395_tcp_listen(0);
//        stop_if_error(rc);
//		    break;
//		case TCP_CLIENT_MODE:
//			 sockinf[socketid].TcpMode = TCP_CLIENT_MODE;
//			 ch395_set_socket_desip(socketid,Socket0DesIP);
//		   ch395_set_socket_desport(socketid,desport);
//		   rc=ch395_open_socket(socketid);
//		   stop_if_error(rc);
//		   rc=ch395_tcp_connect(socketid);
//		   stop_if_error(rc);
//		   break;
//	}
//  delay_ms(500);
}

/*********************************************************************************
* Function Name  : Socket_R_S_Buf_Modify
* Description    : Socketշ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void Socket_R_S_Buf_Modify(void )
{

   ch395_set_socket_recv_buf(0,0,4);                                     /* Socket 0 ջ4*512 = 2Kͻ2*512 = 1K*/
   ch395_set_socket_send_buf(0,4,2);  
  
   ch395_set_socket_recv_buf(1,6,4);                                     /* Socket 1 */
   ch395_set_socket_send_buf(1,10,2);  
  
   ch395_set_socket_recv_buf(2,12,4);                                    /* Socket 2 */
   ch395_set_socket_send_buf(2,16,8);  
  
   ch395_set_socket_recv_buf(3,24,4);                                    /* Socket 3 */
   ch395_set_socket_send_buf(3,28,8);  
  
   ch395_set_socket_recv_buf(4,36,4);                                    /* Socket 4 */
   ch395_set_socket_send_buf(4,40,8);  
//  
//   ch395_set_socket_recv_buf(5,36,4);                                    /* Socket 5 */
//   ch395_set_socket_send_buf(5,40,8);
//  
//   ch395_set_socket_recv_buf(6,36,4);                                    /* Socket 6 */
//   ch395_set_socket_send_buf(6,40,2);  
//  
//   ch395_set_socket_recv_buf(7,42,4);                                    /* Socket 7 */
//   ch395_set_socket_send_buf(7,46,2);  
}


/**********************************************************************************
* Function Name  : KeepLive_Set
* Description    : ʱ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void KeepLive_Set(void)
{
//	ch395_keeplive_cnt(DEF_KEEP_LIVE_CNT);
//	ch395_keeplive_idle(DEF_KEEP_LIVE_IDLE);
//	ch395_keeplive_intvl(DEF_KEEP_LIVE_PERIOD);
}
