/********************************** (C) COPYRIGHT  *******************************
* File Name          : MCU_communication_interface.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/10/12
* Description        : CH32 ͨӿ
*******************************************************************************/
#include "stdio.h"
#include "MCU_communication_interface.h"
#include "delay.h"

#define SPI1_SR   *(uint32_t*)(0x40013008)
#define SPI1_DR   *(uint32_t*)(0x4001300C)

void Control_IO_Init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	/* CH395ж PA0*/
   GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;	/* CH395жãƬΪ */
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 
	GPIO_Init( GPIOA, &GPIO_InitStructure );
	
	/* CH395Ӳλ PA1*/
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;	
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;   
	GPIO_Init( GPIOA, &GPIO_InitStructure );
	GPIO_SetBits(GPIOA,GPIO_Pin_1);
}


/*******************************************************************************
* Function Name  : SPI_FullDuplex_Init
* Description    : Configuring the SPI for full-duplex communication.
* Input          : None
* Return         : None
*******************************************************************************/ 
void SPI_FullDuplex_Init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	SPI_InitTypeDef SPI_InitStructure;	
	
	RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA | RCC_APB2Periph_SPI1, ENABLE );	
		
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;	
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init( GPIOA, &GPIO_InitStructure );	

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;	
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init( GPIOA, &GPIO_InitStructure );	

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;	
	GPIO_Init( GPIOA, &GPIO_InitStructure );	
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;		
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init( GPIOA, &GPIO_InitStructure );
	
	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;	
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;	
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;	
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;	
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;	
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4;
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;	
	SPI_InitStructure.SPI_CRCPolynomial = 7;
	SPI_Init( SPI1, &SPI_InitStructure );	
	
	SPI_Cmd( SPI1, ENABLE );
}

void CH395_SPI_Init(void)
{
	SPI_FullDuplex_Init();
	Control_IO_Init();
}
/**
*ɣд
 */
void ch395_write_cmd( uint8_t mCmd )
{
	ch395_scs_hign;                /* ֹCSԭΪͣȽCSø */
  ch395_scs_low;                 /* ʼCS */
	
  ch395_write_data(mCmd);        /* SPI */
	delay_us(2);                   /* Ҫʱ,ʱ1.5uSȷдڲС1.5uS */
}


uint8_t SPI1_ReadByte(uint8_t Tx_Data)
{		
	u8 i=0;		
	while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET)
	{
		i++;
		if(i>200)return 0;
	}		
	return SPI_I2S_ReceiveData(SPI1); 	
	
}

/**
----------------------------------------  CH395Ӳдȡ -----------------------------------------
---------------------------------------  ֲAPIλ -----------------------------------------
 */
void ch395_write_data( uint8_t mData )
{	
	while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET) ;
	SPI_I2S_SendData(SPI1, mData); 
	while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET);
	SPI_I2S_ReceiveData(SPI1); 
}

void spi_data_write(uint8_t mData)
{
	while ((SPI1_SR & SPI_I2S_FLAG_TXE) == RESET) ;	
	SPI1_DR=mData;
}

/**
-----------------------------------------  CH395Ӳȡ -----------------------------------------
----------------------------------------  ֲAPIλ -----------------------------------------
 */
uint8_t ch395_read_data( void )
{
	while((SPI1_SR & SPI_I2S_FLAG_TXE)==RESET);	
	SPI1_DR=0xff;
	while((SPI1_SR & SPI_I2S_FLAG_RXNE)==RESET);	
	return (uint8_t)SPI1->DR;
}




