#include "transport.h"
#include "string.h"
#include "CH395_interface_operation.h"
#include "ch395.h"
#include "ch395inc.h"
#include "CH395_network_operation.h"
#include "CH395_interface_operation.h"
#include "MCU_communication_interface.h"
#include "MQTTPacket.h"

extern struct   _SOCK_INF sockinf[8]; 
extern uint16_t packetid;

void transport_sendPacketBuffer(uint8_t socketid, uint8_t* buf, uint32_t buflen)
{
	ch395_send_data(socketid, buf, buflen);
}


s32 transport_getdata(u8* buf, s32 count)
{
	s32 rc;
//  rc = ch395_get_recv_data(mysock, buf, count, 0);
	return rc;
}


uint8_t transport_open(uint8_t socketid,uint8_t* servip, uint16_t srcport)
{
	uint8_t rc;

	ch395_set_socket_prot_type(socketid,PROTO_TYPE_TCP);
	ch395_set_socket_sourport(socketid,srcport);
  sockinf[socketid].TcpMode = TCP_CLIENT_MODE;
	ch395_set_socket_desip(socketid,servip);
  ch395_set_socket_desport(socketid,61613);
	rc=ch395_open_socket(socketid);
	stop_if_error(rc);
	rc=ch395_tcp_connect(socketid);
	stop_if_error(rc);
  delay_ms(500);
}


uint8_t transport_close(uint8_t sockindex)
{
	uint8_t rc;
	rc = ch395_close_socket(sockindex);
	return rc;
}


void MQTT_Subscribe(uint8_t socketid, char *topic)
{
	MQTTString topicString = MQTTString_initializer;
	int req_qos=0;
	uint32_t len;
	uint32_t msgid=1;
	uint8_t buf[200];
	
	topicString.cstring=topic;
	len=MQTTSerialize_subscribe(buf,sizeof(buf),0,msgid,1,&topicString,&req_qos);
	transport_sendPacketBuffer(socketid,buf,len);
}


void MQTT_Connect(uint8_t socketid, char *username,char *password)
{
	MQTTPacket_connectData data = MQTTPacket_connectData_initializer;
	uint32_t len;
	uint8_t buf[200];

	data.clientID.cstring = "11";
	data.keepAliveInterval = 20;
	data.cleansession = 1;
	data.username.cstring = username;																		
	data.password.cstring = password;
	 
	len=MQTTSerialize_connect(buf,sizeof(buf),&data);											
	transport_sendPacketBuffer(socketid,buf,len);						
}

void MQTT_Publish(uint8_t socketid, char *topic, unsigned char *payload)
{
	MQTTString topicString = MQTTString_initializer;
	uint32_t payloadlen;
	uint32_t len;
	uint8_t buf[1024];
	
	topicString.cstring=topic; 
	payloadlen=strlen(payload);
	len= MQTTSerialize_publish(buf,sizeof(buf),0,0,0,packetid++,topicString,payload,payloadlen);	
	transport_sendPacketBuffer(socketid,buf,len);
}


void MQTT_Pingreq(uint8_t socketid)
{
	uint32_t len;
	uint8_t buf[200];
	
	len=MQTTSerialize_pingreq(buf,sizeof(buf));
	transport_sendPacketBuffer(socketid,buf,len);
}


